--Frame Create
local lagMonitorFrame = CreateFrame("Frame", "LagMonitorFrame", UIParent);
local ilevelFrame = CreateFrame("Frame", "ItemLevelFrame", UIParent);
local currencyFrame = CreateFrame("Frame", "CurrencyFrame", UIParent);

--FontStrings(PingFrame)
local pingLocal = lagMonitorFrame:CreateFontString("PLocal", "OVERLAY");
local pingWorld = lagMonitorFrame:CreateFontString("PWorld", "OVERLAY");
local pLocal = lagMonitorFrame:CreateFontString("PLocal", "OVERLAY");
local pWorld = lagMonitorFrame:CreateFontString("PWorld", "OVERLAY");
local gFPS = lagMonitorFrame:CreateFontString("GFPS", "OVERLAY");
local gameFPS = lagMonitorFrame:CreateFontString("GFPS", "OVERLAY");

--FontStrings(IlevelFrame)
local ilevel = ilevelFrame:CreateFontString("ILVL", "OVERLAY");
local ilevelStats = ilevelFrame:CreateFontString("ILVLS", "OVERLAY");

--FontStrings(CurrencyFrame)
local gold = currencyFrame:CreateFontString("GOLD", "OVERLAY");

--Variables
local updateInterval = 0;
local addonLoadedMessage = 'v2.0';
local defaultFont = 1;
local defaultGroup = 1;
local currencyFrameWidth = 250;
local currencyFrameHeight = 25;
local itemFrameWidth = 175;
local itemFrameHeight = 25;
local statsFramesHeight = 75;
local statsFramesWitdh = 150;
local minLagHeight = 25;
local minLagWidth = 50;
local minCurrencyHeight = 15;
local minCurrencyWidth = 200;
local minItemHeight = 15;
local minItemWidth = 75;


--LibSharedMedia
local LSM = LibStub("LibSharedMedia-3.0");
LagMonitor = LibStub("AceAddon-3.0"):NewAddon("LagMonitor", "AceConsole-3.0", "AceEvent-3.0")

--Global variables
local userFont = {
		"Frizqt(Game - Default)",
		"Skurri(Game)",
		"Morpheus(Game)",
		"Arialn(Game)",
		"Shangri-la",
		"Bascula College",
		"Sigismundus",
		"Seasrn",
		"Caviar Dreams",
		"Blkchry",
		"Carnevalee Freakshow",
		"Good Times",
		"Price Down"
}

local chatGroup = {
		"SAY",
		"YELL",
		"PARTY",
		"GUILD",
		"RAID",
		"INSTANCE_CHAT",
}

local myFont = LSM:Fetch("font",userFont);

--LagMonitorFrame
local LagMonitorBody=lagMonitorFrame:CreateTexture(nil,"ARTWORK")

--ilevelFrame
local IlevelBody=ilevelFrame:CreateTexture(nil,"ARTWORK")

--CurrencyFrame
local CurrencyBody=currencyFrame:CreateTexture(nil,"ARTWORK")

--Move currencyFrame
local OnMouseDown = function(currencyFrame, button)
if button == "RightButton" and IsShiftKeyDown() then
local group = chatGroup[LagMonitor.db.profile.bcGroup];
local copper = GetMoney();
	SendChatMessage("I have " .. GetCoinText(copper), group);
end
    if button == "LeftButton" then
        currencyFrame:StartMoving()
        currencyFrame.isMoving = true
        currencyFrame.hasMoved = false
		elseif button == "RightButton" then
		if IsAltKeyDown() == true then
			currencyFrame:StartSizing()
			currencyFrame.isMoving = true
			currencyFrame.hasMoved = false
		end
    end
end

function OnMouseUp(currencyFrame)
    if ( currencyFrame.isMoving ) then
        currencyFrame:StopMovingOrSizing();
        currencyFrame.isMoving = false;
        currencyFrame.hasMoved = true;
    end
end

function OnHide(currencyFrame)       
    if ( currencyFrame.isMoving ) then
        currencyFrame:StopMovingOrSizing();
        currencyFrame.isMoving = false;
    end
end

currencyFrame:RegisterForDrag("LeftButton","RightButton");
currencyFrame:EnableMouse(true);
currencyFrame:SetMovable(true);
currencyFrame:SetResizable(true);
currencyFrame:SetScript("OnMouseDown",OnMouseDown);
currencyFrame:SetScript("OnMouseUp", OnMouseUp);
currencyFrame:SetScript("OnHide", OnHide);

--Move ItemLevelFrame
local OnMouseDown = function(ItemLevelFrame, button)
if button == "RightButton" and IsShiftKeyDown() then
local group = chatGroup[LagMonitor.db.profile.bcGroup];
local equipped = GetAverageItemLevel(2);

rEquipped = round(equipped, 2);
SendChatMessage("My item level: " .. rEquipped, group);
end
    if button == "LeftButton" then
        ItemLevelFrame:StartMoving()
        ItemLevelFrame.isMoving = true
        ItemLevelFrame.hasMoved = false
		elseif button == "RightButton" then
		if IsAltKeyDown() == true then
			ItemLevelFrame:StartSizing()
			ItemLevelFrame.isMoving = true
			ItemLevelFrame.hasMoved = false
		end
    end
end

function OnMouseUp(ItemLevelFrame)
    if ( ItemLevelFrame.isMoving ) then
        ItemLevelFrame:StopMovingOrSizing();
        ItemLevelFrame.isMoving = false;
        ItemLevelFrame.hasMoved = true;
    end
end

function OnHide(ItemLevelFrame)       
    if ( ItemLevelFrame.isMoving ) then
        ItemLevelFrame:StopMovingOrSizing();
        ItemLevelFrame.isMoving = false;
    end
end

ItemLevelFrame:RegisterForDrag("LeftButton","RightButton");
ItemLevelFrame:EnableMouse(true);
ItemLevelFrame:SetMovable(true);
ItemLevelFrame:SetResizable(true);
ItemLevelFrame:SetScript("OnMouseDown",OnMouseDown);
ItemLevelFrame:SetScript("OnMouseUp", OnMouseUp);
ItemLevelFrame:SetScript("OnHide", OnHide);

--Move LagMonitorFrame
local OnMouseDown = function(lagMonitorFrame, button)
if button == "RightButton" and IsShiftKeyDown() then
local group = chatGroup[LagMonitor.db.profile.bcGroup];
local up, down, home, world = GetNetStats();
SendChatMessage("My latency: Home: " .. home .. " World: " .. world, group);
end
    if button == "LeftButton" then
        lagMonitorFrame:StartMoving()
        lagMonitorFrame.isMoving = true
        lagMonitorFrame.hasMoved = false
	elseif (button == "RightButton") then
		if IsAltKeyDown() == true then
			lagMonitorFrame:StartSizing()
			lagMonitorFrame.isMoving = true
			lagMonitorFrame.hasMoved = false
		end
    end
end

function OnMouseUp(lagMonitorFrame)
    if ( lagMonitorFrame.isMoving ) then
        lagMonitorFrame:StopMovingOrSizing();
        lagMonitorFrame.isMoving = false;
        lagMonitorFrame.hasMoved = true;
    end
end

function OnHide(lagMonitorFrame)       
    if ( lagMonitorFrame.isMoving ) then
        lagMonitorFrame:StopMovingOrSizing();
        lagMonitorFrame.isMoving = false;
    end
end

lagMonitorFrame:RegisterForDrag("LeftButton","RightButton");
lagMonitorFrame:EnableMouse(true);
lagMonitorFrame:SetMovable(true);
lagMonitorFrame:SetResizable(true);
lagMonitorFrame:SetScript("OnMouseDown",OnMouseDown);
lagMonitorFrame:SetScript("OnMouseUp", OnMouseUp);
lagMonitorFrame:SetScript("OnHide", OnHide);

lagMonitorFrame:SetMinResize(minLagWidth, minLagHeight); 
currencyFrame:SetMinResize(minCurrencyWidth, minCurrencyHeight); 
ilevelFrame:SetMinResize(minItemWidth, minItemHeight); 

--Register player money
lagMonitorFrame:RegisterEvent("PLAYER_MONEY");
lagMonitorFrame:RegisterEvent("ADDON_LOADED");
lagMonitorFrame:RegisterEvent("PLAYER_LOGIN");
lagMonitorFrame:RegisterEvent("PLAYER_LOGOUT");

--Slash commands
SLASH_PING1 = "/ping";
SLASH_PING2 = "/latency";
SLASH_PING3 = "/ms";
SLASH_FPS1 = "/lmfps";
SLASH_FPS2 = "/framerate";
SLASH_FPS3 = "/fps";
SLASH_RESET1 = "/lmreset";
SLASH_ITEM1 = "/lmilvl";
SLASH_ITEM2 = "/ilvl";
SLASH_GOLD1 = "/gold";
SLASH_GOLD2 = "/currency";
SLASH_GOLD3 = "/money";
SLASH_HELP1 = "/lmhelp";
SLASH_HELP2 = "/lminfo";
SLASH_CLOSE1 = "/lmclose";
SLASH_CLOSE2 = "/lmexit";
SLASH_DISPLAY1 = "/lmdisplay";
SLASH_DISPLAY2 = "/lmopen";
SLASH_CLAMP1 = "/lmclamp";
SLASH_CLAMP2 = "/clamp";
SLASH_LOCK1 = "/lmlock";
SLASH_LOCK2 = "/lock";
SLASH_RESIZE1 = "/resize";
SLASH_RESIZE2 = "/lmresize";

 SlashCmdList["LOCK"] = function(self, txt)
local value = LagMonitor.db.profile.locked;

	if value == true then
		LagMonitor:Print("All frames are unlocked!");
		LagMonitor.db.profile.locked = false;
		lockFrames(LagMonitor.db.profile.locked);
	elseif value == false then
		LagMonitor:Print("All frames are locked!");
		LagMonitor.db.profile.locked = true;
		lockFrames(LagMonitor.db.profile.locked);
	end
end

SlashCmdList["CLAMP"] = function(self, txt)
local clamped = LagMonitor.db.profile.isClamped;

	if clamped == true then
		lagMonitorFrame:SetClampedToScreen(false);
		currencyFrame:SetClampedToScreen(false);
		ilevelFrame:SetClampedToScreen(false);
		LagMonitor.db.profile.isClamped = false;
		LagMonitor:Print("All frames are unclamped from screen!");
	elseif clamped == false then
		lagMonitorFrame:SetClampedToScreen(true);
		currencyFrame:SetClampedToScreen(true);
		ilevelFrame:SetClampedToScreen(true);
		LagMonitor.db.profile.isClamped = true;
		LagMonitor:Print("All frames are clamped to screen!");
	end
end

SlashCmdList["DISPLAY"] = function(self, txt)
    LagMonitor.db.profile.closed = false;
	lagMonitorFrame:Show();
	currencyFrame:Show();
	ilevelFrame:Show();
end

SlashCmdList["CLOSE"] = function(self, txt)
    LagMonitor.db.profile.closed = true;
	LagMonitor:Print("LagMonitor is now closed!");
	LagMonitorFrame:Hide();
	currencyFrame:Hide();
	ilevelFrame:Hide();
end

SlashCmdList["HELP"] = function(self, txt)
	LagMonitor:Print("Commands available to use!");
	LagMonitor:Print("/ping - Displays home/world latency!");
	LagMonitor:Print("/fps - Displays the current frames per second!");
	LagMonitor:Print("/lmreset - Resets the addon to default settings!");
	LagMonitor:Print("/ilvl - Displays the item level of your character!");
	LagMonitor:Print("/gold - Displays the gold of your character!");
	LagMonitor:Print("/lmclose - Closes the addon!");
	LagMonitor:Print("/lmopen - Opens the addon!");
	LagMonitor:Print("/lmclamp - Clamps/unclamps the frames from the screen!");
	LagMonitor:Print("/lmlock - Lock/unlock the frames!");
	LagMonitor:Print("/lmresize - Enable/disable the ability to resize!");
	LagMonitor:Print("You can resize the frames by holding 'ALT' while 'right-click' dragging. NOTE: Frames are not resizable when frames are locked!");
	LagMonitor:Print("You can broadcast your latency/item-level and gold by holding 'shift' while 'right-clicking' on the appropriate frame. NOTE: You can change the chat group in the interface menu for example: 'PARTY'!");
end

SlashCmdList["ITEM"] = function(self, txt)
	local overall, equipped = GetAverageItemLevel();
	LagMonitor:Print("Equipped Gear Item Level: " .. equipped);
	LagMonitor:Print("Overall Gear Item Level: " .. overall);
end

SlashCmdList["FPS"] = function(self, txt)
	local fps = GetFramerate();
	LagMonitor:Print("Framerate: " .. floor(fps));
	ShowColorPicker(r, g, b, a, myColorCallback);
end

SlashCmdList["RESET"] = function(self, txt)
	ResetSettings();
end

SlashCmdList["PING"] = function(self, txt)
	local up, down, home, world = GetNetStats();
	LagMonitor:Print("Home ping: " .. home);
	LagMonitor:Print("World ping: " .. world);
end

SlashCmdList["GOLD"] = function(self, txt)
	local copper = GetMoney()
	LagMonitor:Print(comma_value(GetCoinTextureString(copper)))
end

function round(number, decimals)
	local power = 10^decimals;
    return math.floor(number * power) / power;
end

local options = {
    name = "LagMonitor",
    handler = LagMonitor,
    type = 'group',
    args = {
	
        showColText = {
            type = "toggle",
            name = "Toggle Colors",
			order = 1,
			desc = "Enable/disable colors stating quality of gameplay, for example: Green is Optimal, Orange/Yellow is Playable and Red is Poor!",
            get = "IsShowColText",
            set = "ToggleShowColText",
        },
		fontThickOutline = {
			type = "toggle",
			name = "Font Thick Outline",
			order = 2,
			desc = "Enable/disable a thick font outline!",
			get = "IsThickOutline",
			set = "ToggleThickOutline"
		},
        closed = {
            type = "toggle",
            name = "Close",
			order = 3,
			desc = "Closes all current open frames on the screen! - You will not lose any data by closing the addon!",
            get = "IsClosed",
            set = "ToggleIsClosed"
        },
		showItemLevel = {
		    type = "toggle",
            name = "Item Level",
			order = 4,
			desc = "Show/Hide a frame displaying your Item Level!",
            get = "ShowItemLevel",
            set = "ToggleItemLevel"
        },
		showCurrency = {
		    type = "toggle",
            name = "Currency",
			order = 5,
			desc = "Show/Hide a frame displaying your main gold currency!",
            get = "ShowCurrency",
            set = "ToggleCurrency"
        },
		clampToScreen = {
			type = "toggle",
			name = "Clamp",
			order = 6,
			desc = "Enable/disable the ability for frames to be locked inside the current window!",
			get = "IsClamped",
			set = "ToggleClamped"
		},
		lockFrame = {
			type = "toggle",
			name = "Lock",
			order = 7,
			desc = "Locks all frames in their current positions!",
			get = "isLocked",
			set = "ToggleLocked"
		},
		shortName = {
			type = "toggle",
			name = "Short Names",
			order = 8,
			desc = "Toggle between showing the whole word or only the starting letter on all frames!",
			get = "isShort",
			set = "ToggleShort"
		},
		homePing = {
			type = "toggle",
			name = "Home Ping",
			order = 9,
			desc = "Show/Hide your home ping!",
			get = "homePingShow",
			set = "ToggleHomePing"
		},
		worldPing = {
			type = "toggle",
			name = "World Ping",
			order = 10,
			desc = "Show/Hide your world ping!",
			get = "worldPingShow",
			set = "ToggleWorldPing"
		},
		fps = {
			type = "toggle",
			name = "FPS",
			order = 11,
			desc = "Show/Hide your fps!",
			get = "fpsShow",
			set = "ToggleFps"
		},
		backgroundcol = {
			type = "range",
			name = "Background Transparency",
			order = 12,
			min = 0,
			max = 1,
			desc = "Change the transparency of the background of all frames!",
			get = "currentBackgroundCol",
			set = "changeBackgroundCol",
			step = 0.01
		},
		changeFont = {
			type = "range",
			name = "Change Font Size",
			order = 13,
			min = 7,
			max = 32,
			desc = "Changes the size of the fonts! NOTE: Change the size of the frame if the font size is too big or does not fit!",
			get = "currentFontSize",
			set = "changeFontSize",
			step = 1
		},
		activeFont = {
			type = "select",
			name = "Fonts",
			order = 14,
			desc = "Pick from a list of fonts readily made available to use for the addon!",
			values = userFont,
			get = "currentFont",
			set = "changeFont"
		},
		bcGroups = {
			type = "select",
			name = "Group",
			order = 15,
			desc = "Select the group you would like to broadcast to!",
			values = chatGroup,
			get = "currentBcGroup",
			set = "changeBcGroup"
		},
		reset = {
			type = "execute",
			name = "Reset",
			order = 16,
			desc = "Reset all the settings back to the default settings!",
			func = "ToggleIsReset"
		},
    },
}

function LagMonitor:worldPingShow(info)
	return self.db.profile.worldPingShow;
end

function LagMonitor:ToggleWorldPing(info, value)
	self.db.profile.worldPingShow = value;
	SortOrder();
	if value == true then
		lagMonitorFrame:Show();
		pWorld:Show();
		pingWorld:Show();
	end
	if value == false then
		pWorld:Hide();
		pingWorld:Hide();
	end
end

function LagMonitor:fpsShow(info)
	return self.db.profile.fpsShow;
end

function LagMonitor:ToggleFps(info, value)
	self.db.profile.fpsShow = value;
	SortOrder();
	if value == true then
		lagMonitorFrame:Show();
		gFPS:Show();
		gameFPS:Show();
	end
	if value == false then
		gFPS:Hide();
		gameFPS:Hide();
	end
end

function LagMonitor:homePingShow(info)
	return self.db.profile.homePingShow;
end

function LagMonitor:ToggleHomePing(info, value)
	self.db.profile.homePingShow = value;
	SortOrder();
	if value == true then
		lagMonitorFrame:Show();
		pLocal:Show();
		pingLocal:Show();
	end
	if value == false then
		pLocal:Hide();
		pingLocal:Hide();
	end
end

function LagMonitor:currentBcGroup(info)
	return self.db.profile.bcGroup;
end

function LagMonitor:changeBcGroup(info, value)
	self.db.profile.bcGroup = value;
end

function LagMonitor:isShort(info)
	return self.db.profile.short;
end

function LagMonitor:ToggleShort(info, value)
	self.db.profile.short = value;
	if value == false then 
		pLocal:SetFormattedText("Home(ms):"); 
		pWorld:SetFormattedText("World(ms):"); 
		gFPS:SetFormattedText("FPS:"); 
		ilevel:SetFormattedText("ILevel:"); 
	end 
	if value == true then 
		pLocal:SetFormattedText("H:");
		pWorld:SetFormattedText("W:"); 
		gFPS:SetFormattedText("F:"); 
		ilevel:SetFormattedText("I:"); 
	end
end

function LagMonitor:isLocked(info)
	return self.db.profile.locked;
end

function LagMonitor:ToggleLocked(info, value)
	self.db.profile.locked = value;
	if value == true then
		lockFrames(value);
		self:Print("All frames are locked!");
		self.db.profile.locked = true;
	end
	if value == false then
		lockFrames(value);
		self:Print("All frames are unlocked!");
		self.db.profile.locked = false;
	end
end

function LagMonitor:IsClamped(info)
	return self.db.profile.isClamped;
end

function LagMonitor:ToggleClamped(info, value)
	self.db.profile.isClamped = value;
	lagMonitorFrame:SetClampedToScreen(value);
	currencyFrame:SetClampedToScreen(value);
	ilevelFrame:SetClampedToScreen(value);
end

function LagMonitor:ShowItemLevel(info)
	return self.db.profile.showItemLevel;
end

function LagMonitor:ShowCurrency(info)
	return self.db.profile.showCurrency;
end

function LagMonitor:ToggleItemLevel(info, value)
	self.db.profile.showItemLevel = value;
	if value == true then
		ItemLevelFrame:Show();
	end
	if value == false then
		ItemLevelFrame:Hide();
	end
end

function LagMonitor:ToggleCurrency(info, value)
	self.db.profile.showCurrency = value;
	if value == true then
		currencyFrame:Show();
	end
	if value == false then
		currencyFrame:Hide();
	end
end

function LagMonitor:IsThickOutline(info)
	return self.db.profile.thickOutline;
end

function LagMonitor:ToggleThickOutline(info, value)
	self.db.profile.thickOutline = value;
end

function LagMonitor:currentFont(info)
	return self.db.profile.activeFont;
end

function LagMonitor:changeFont(info, value)
	self.db.profile.activeFont = value;
	myFont = LSM:Fetch("font","Font" .. value);
end

function LagMonitor:currentFontSize(info)
	return self.db.profile.fontSize
end

function LagMonitor:currentBackgroundCol(info)
	return self.db.profile.backgroundcol
end

function LagMonitor:changeBackgroundCol(info, value)
	self.db.profile.backgroundcol = value;
	LagMonitorBody:SetVertexColor(0.1, 0.1, 0.1, value);
	IlevelBody:SetVertexColor(0.1, 0.1, 0.1, value);
	CurrencyBody:SetVertexColor(0.1, 0.1, 0.1, value);
end

function LagMonitor:changeFontSize(info, value)
	self.db.profile.fontSize = value;
end

function LagMonitor:ToggleIsReset(info, value)
	ResetSettings();
end

function LagMonitor:IsShowColText(info)
    return self.db.profile.showColText
end

function LagMonitor:ToggleShowColText(info, value)
    self.db.profile.showColText = value
	ShowColText();
end

function LagMonitor:IsClosed(info)
    return self.db.profile.closed
end

function LagMonitor:ToggleIsClosed(info, value)
    self.db.profile.closed = value
	if value == true then
		lagMonitorFrame:Hide();
		currencyFrame:Hide();
		ilevelFrame:Hide();
	end
	if value == false then
		lagMonitorFrame:Show();
		currencyFrame:Show();
		ilevelFrame:Show();
	end
end

local defaults = {
    profile = {
		statsHeight = statsFramesHeight,
		statsWidth = statsFramesWitdh,
		ilevelHeight = itemFrameHeight,
		ilevelWidth = itemFrameWidth,
		currencyHeight = currencyFrameHeight,
		currencyWidth = currencyFrameWidth,
		statsPoint = "CENTER",
		statsRelativePoint = "CENTER",
		statsxOfs = 0,
		statsyOfs = 0,
		itemPoint = "CENTER",
		itemRelativePoint = "TOP",
		itemxOfs = 0,
		itemyOfs = -50,
		currencyPoint = "CENTER",
		currencyRelativePoint = "TOP",
		currencyxOfs = 0,
		currencyyOfs = -25,
        showColText = true,
		showItemLevel = false,
		homePingShow = true,
		worldPingShow = true,
		fpsShow = true,
		isClamped = false,
		short = false,
		locked = false,
		showCurrency = false,
        closed = false,
		fontSize = 15,
		backgroundcol = 1,
		bcGroup = defaultGroup,
		activeFont = defaultFont,
		thickOutline = false,
    },
}

function LagMonitor:OnInitialize()
    -- Called when the addon is loaded
	self:Print(addonLoadedMessage .. " Loaded!")
	self.db = LibStub("AceDB-3.0"):New("LagMonitorDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("LagMonitor", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("LagMonitor", "LagMonitor")
end

local function eventHandler(self, event)
	if event == "ADDON_LOADED" then
	
	OutlineSetting();
	--Currency Frame Settings
		frameDeclare(CurrencyBody, currencyFrame);
		gold:SetPoint("RIGHT", currencyFrame, "RIGHT", -10, 0);
		gold:SetTextColor(1, 1, 0, 1);
		
	--Item Level Frame Settings
		frameDeclare(IlevelBody, ilevelFrame);
		ilevel:SetPoint("LEFT", ilevelFrame, "LEFT", 0, 0);
		ilevelStats:SetPoint("RIGHT", ilevelFrame, "RIGHT", 0, 0);
		ilevelStats:SetTextColor(1, 1, 0, 1);
		ilevel:SetTextColor(1, 1, 0, 1);
		ilevel:SetFormattedText("ILevel:");
		
	--Lag Monitor Frame Settings
		frameDeclare(LagMonitorBody, lagMonitorFrame);
			--Assign Local ping fonts
		pingLocal:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		
			--Assign Game fps fonts
		pLocal:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
		pLocal:SetTextColor(1, 1, 0, 1);
		pLocal:SetFormattedText("Home(ms):");
		
			--Assign World ping fonts
		pingWorld:SetPoint("RIGHT", lagMonitorFrame, "RIGHT", 0, 0);
		
			--Assign Game fps fonts
		pWorld:SetPoint("LEFT", lagMonitorFrame, "LEFT", 0, 0);		
		pWorld:SetTextColor(1, 1, 0, 1);
		pWorld:SetFormattedText("World(ms):");
		
			--Assign Game fps fonts
		gameFPS:SetPoint("RIGHT", lagMonitorFrame, "BOTTOMRIGHT" , 0, 12);	
		
			--Assign Game fps fonts
		gFPS:SetPoint("LEFT", lagMonitorFrame, "BOTTOMLEFT", 0, 12);		
		gFPS:SetTextColor(1, 1, 0, 1);
		gFPS:SetFormattedText("FPS:");
		
		AddonLoaded();
		framePositions();
	end
	if event == "PLAYER_LOGIN" then
		goldUpdate();
		framePositions();
		declareFont();
	end
		
	if event == "PLAYER_MONEY" then
		goldUpdate();
	end	
	if event == "PLAYER_LOGOUT" then
	point1, relativeTo1, relativePoint1, xOfs1, yOfs1 = lagMonitorFrame:GetPoint();
	point2, relativeTo2, relativePoint2, xOfs2, yOfs2 = ilevelFrame:GetPoint();
	point3, relativeTo3, relativePoint3, xOfs3, yOfs3 = currencyFrame:GetPoint();
	--Store Frame Sizes
		LagMonitor.db.profile.statsWidth = lagMonitorFrame:GetWidth();
		LagMonitor.db.profile.statsHeight = lagMonitorFrame:GetHeight();
		LagMonitor.db.profile.ilevelWidth = ilevelFrame:GetWidth();
		LagMonitor.db.profile.ilevelHeight = ilevelFrame:GetHeight();
		LagMonitor.db.profile.currencyWidth = currencyFrame:GetWidth();
		LagMonitor.db.profile.currencyHeight = currencyFrame:GetHeight();
	--Store Frame Positions
		LagMonitor.db.profile.statsPoint = point1;
		LagMonitor.db.profile.statsRelativePoint = relativePoint1;
		LagMonitor.db.profile.statsxOfs = xOfs1;
		LagMonitor.db.profile.statsyOfs = yOfs1;
		LagMonitor.db.profile.itemPoint = point2;
		LagMonitor.db.profile.itemRelativePoint = relativePoint2;
		LagMonitor.db.profile.itemxOfs = xOfs2;
		LagMonitor.db.profile.itemyOfs = yOfs2;
		LagMonitor.db.profile.currencyPoint = point3;
		LagMonitor.db.profile.currencyRelativePoint = relativePoint3;
		LagMonitor.db.profile.currencyxOfs = xOfs3;
		LagMonitor.db.profile.currencyyOfs = yOfs3;
	end
end

lagMonitorFrame:SetScript("OnEvent", eventHandler);

function frameDeclare(body, frame)
		body:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
		body:SetAllPoints(frame)
		body:SetVertexColor(0.1, 0.1, 0.1, LagMonitor.db.profile.backgroundcol)
end
	
function declareFont()
myFont = LSM:Fetch("font","Font" .. LagMonitor.db.profile.activeFont);
end

function framePositions()
lagMonitorFrame:ClearAllPoints();
currencyFrame:ClearAllPoints();
ilevelFrame:ClearAllPoints();
--Set Frame (LagMonitorFrame)
	lagMonitorFrame:SetPoint(LagMonitor.db.profile.statsPoint, UIParent, LagMonitor.db.profile.statsRelativePoint, LagMonitor.db.profile.statsxOfs, LagMonitor.db.profile.statsyOfs);
	lagMonitorFrame:SetSize(LagMonitor.db.profile.statsWidth, LagMonitor.db.profile.statsHeight);

--Set frame (ilevelFrame)
	ilevelFrame:SetPoint(LagMonitor.db.profile.itemPoint, UIParent, LagMonitor.db.profile.itemRelativePoint, LagMonitor.db.profile.itemxOfs, LagMonitor.db.profile.itemyOfs);
	ilevelFrame:SetSize(LagMonitor.db.profile.ilevelWidth, LagMonitor.db.profile.ilevelHeight);

--Set frame (CurrencyFrame)
	currencyFrame:SetPoint(LagMonitor.db.profile.currencyPoint, UIParent, LagMonitor.db.profile.currencyRelativePoint, LagMonitor.db.profile.currencyxOfs, LagMonitor.db.profile.currencyyOfs);
	currencyFrame:SetSize(LagMonitor.db.profile.currencyWidth, LagMonitor.db.profile.currencyHeight);
end

function AddonLoaded()
	lockFrames(LagMonitor.db.profile.locked);
		if LagMonitor.db.profile.closed == true then
			lagMonitorFrame:Hide();
			currencyFrame:Hide();
			ItemLevelFrame:Hide();
		end
		if LagMonitor.db.profile.closed == false then
			lagMonitorFrame:Show();
			currencyFrame:Show();
			ItemLevelFrame:Show();
		end
		if LagMonitor.db.profile.showCurrency == true then
			currencyFrame:Show();
		end
		if LagMonitor.db.profile.showCurrency == false then
			currencyFrame:Hide();
		end
		if LagMonitor.db.profile.showItemLevel == true then
			ItemLevelFrame:Show();
		end
		if LagMonitor.db.profile.showItemLevel == false then
			ItemLevelFrame:Hide();
		end
		SortOrder();
		if LagMonitor.db.profile.homePingShow == false then
			pLocal:Hide();
			pingLocal:Hide();
		end
		if LagMonitor.db.profile.worldPingShow == false then
			pWorld:Hide();
			pingWorld:Hide();
		end
		if LagMonitor.db.profile.fpsShow == false then
			gFPS:Hide();
			gameFPS:Hide();
		end	
		if LagMonitor.db.profile.homePingShow == true then
			pLocal:Show();
			pingLocal:Show();
		end
		if LagMonitor.db.profile.worldPingShow == true then
			pWorld:Show();
			pingWorld:Show();
		end
		if LagMonitor.db.profile.fpsShow == true then
			gFPS:Show();
			gameFPS:Show();
		end	
		if LagMonitor.db.profile.isClamped == true then
			lagMonitorFrame:SetClampedToScreen(true);
			currencyFrame:SetClampedToScreen(true);
			ilevelFrame:SetClampedToScreen(true);
		end
		if LagMonitor.db.profile.isClamped == false then
			lagMonitorFrame:SetClampedToScreen(false);
			currencyFrame:SetClampedToScreen(false);
			ilevelFrame:SetClampedToScreen(false);
		end
		if LagMonitor.db.profile.short == false then 
		pLocal:SetFormattedText("Home(ms):"); 
		pWorld:SetFormattedText("World(ms):"); 
		gFPS:SetFormattedText("FPS:"); 
		ilevel:SetFormattedText("ILevel:"); 
		end 
		if LagMonitor.db.profile.short == true then 
		pLocal:SetFormattedText("H:");
		pWorld:SetFormattedText("W:"); 
		gFPS:SetFormattedText("F:"); 
		ilevel:SetFormattedText("I:"); 
		end
end

function iLevelSetting()
	local overall, equipped = GetAverageItemLevel();
	rOverall = round(overall, 2);
	rEquipped = round(equipped, 2);
	if equipped ~= overall then
		ilevelStats:SetFormattedText(rEquipped .. "/" .. rOverall);
	end
	if equipped == overall then
		ilevelStats:SetFormattedText(rEquipped);
	end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

local function onUpdate(self, elapsed)
iLevelSetting();
OutlineSetting();
	
updateInterval = updateInterval + elapsed
	if updateInterval >= 1 then	
		ShowColText();	
		updateInterval = 0;
	end
end

lagMonitorFrame:SetScript("OnUpdate", onUpdate);


function FontUpdate()
if LagMonitor.db.profile.activeFont == defaultFont then
	LagMonitor.db.profile.activeFont = defaultFont;
end
end

function OutlineSetting()
--Change font sizes
fontSetting(pingLocal);
fontSetting(pingWorld);
fontSetting(gameFPS);
fontSetting(pLocal);
fontSetting(pWorld);
fontSetting(gFPS);
fontSetting(ilevel);
fontSetting(ilevelStats);
fontSetting(gold);
end

function SortOrder()
	if LagMonitor.db.profile.homePingShow == false and LagMonitor.db.profile.worldPingShow == true and LagMonitor.db.profile.fpsShow == false then
		pingWorld:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pWorld:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
	end
	if LagMonitor.db.profile.homePingShow == false and LagMonitor.db.profile.worldPingShow == true and LagMonitor.db.profile.fpsShow == true then
		pingWorld:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pWorld:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
		gameFPS:SetPoint("RIGHT", lagMonitorFrame, "BOTTOMRIGHT" , 0, 12);
		gFPS:SetPoint("LEFT", lagMonitorFrame, "BOTTOMLEFT" , 0, 12);
	end
	if LagMonitor.db.profile.homePingShow == false and LagMonitor.db.profile.worldPingShow == false and LagMonitor.db.profile.fpsShow == true then
		gameFPS:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT" , 0, -12);
		gFPS:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT" , 0, -12);
	end
	if LagMonitor.db.profile.homePingShow == true and LagMonitor.db.profile.worldPingShow == true and LagMonitor.db.profile.fpsShow == false then
		pingLocal:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pLocal:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
		pingWorld:SetPoint("RIGHT", lagMonitorFrame, "BOTTOMRIGHT", 0, 12);
		pWorld:SetPoint("LEFT", lagMonitorFrame, "BOTTOMLEFT", 0, 12);
	end
	if LagMonitor.db.profile.homePingShow == true and LagMonitor.db.profile.worldPingShow == true and LagMonitor.db.profile.fpsShow == true then
		pingLocal:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pLocal:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
		pingWorld:SetPoint("RIGHT", lagMonitorFrame, "RIGHT", 0, 0);
		pWorld:SetPoint("LEFT", lagMonitorFrame, "LEFT", 0, 0);
		gameFPS:SetPoint("RIGHT", lagMonitorFrame, "BOTTOMRIGHT" , 0, 12);
		gFPS:SetPoint("LEFT", lagMonitorFrame, "BOTTOMLEFT" , 0, 12);
	end
	if LagMonitor.db.profile.homePingShow == true and LagMonitor.db.profile.worldPingShow == false and LagMonitor.db.profile.fpsShow == true then
		pingLocal:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pLocal:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
		gameFPS:SetPoint("RIGHT", lagMonitorFrame, "BOTTOMRIGHT" , 0, 12);
		gFPS:SetPoint("LEFT", lagMonitorFrame, "BOTTOMLEFT" , 0, 12);
	end
	if LagMonitor.db.profile.homePingShow == true and LagMonitor.db.profile.worldPingShow == false and LagMonitor.db.profile.fpsShow == false then
		pingLocal:SetPoint("RIGHT", lagMonitorFrame, "TOPRIGHT", 0, -12);
		pLocal:SetPoint("LEFT", lagMonitorFrame, "TOPLEFT", 0, -12);
	end
	if LagMonitor.db.profile.homePingShow == false and LagMonitor.db.profile.worldPingShow == false and LagMonitor.db.profile.fpsShow == false then
		lagMonitorFrame:Hide();
	end
end

function lockFrames(frameLock)
	if frameLock == false then
		lagMonitorFrame:SetMovable(true);
		ilevelFrame:SetMovable(true);
		currencyFrame:SetMovable(true);
		currencyFrame:SetResizable(true);
		lagMonitorFrame:SetResizable(true);
		ilevelFrame:SetResizable(true);
	elseif frameLock == true then
		lagMonitorFrame:SetMovable(false);
		ilevelFrame:SetMovable(false);
		currencyFrame:SetMovable(false);
		currencyFrame:SetResizable(false);
		lagMonitorFrame:SetResizable(false);
		ilevelFrame:SetResizable(false);
	end
end

function fontSetting(text)
local textFontSize = LagMonitor.db.profile.fontSize;
local outline = LagMonitor.db.profile.thickOutline;

if outline == false then
text:SetFont(myFont,textFontSize,"OUTLINE")
end
if outline == true then
text:SetFont(myFont,textFontSize,"THICKOUTLINE")
end
end

function goldUpdate()
	local copper = GetMoney()
	gold:SetFormattedText(comma_value(GetCoinTextureString(copper)))
end

function ShowColText()
	local up, down, home, world = GetNetStats();
	local fps = GetFramerate();

				if LagMonitor.db.profile.showColText == true then
				if home < 250 then
				pingLocal:SetTextColor(0, 1, 0, 1);
				end
				if ((home >= 250) and (home < 400)) then
				pingLocal:SetTextColor(1, 1, 0, 1);
				end
				if home >= 400 then
				pingLocal:SetTextColor(1, 0, 0, 1);
				end
			end
			if LagMonitor.db.profile.showColText == false then
				pingLocal:SetTextColor(1, 1, 0, 1);
			end
			--Display Local ping
			pingLocal:SetFormattedText(home);
	
				if LagMonitor.db.profile.showColText == true then
				if world < 250 then
				pingWorld:SetTextColor(0, 1, 0, 1);
				end
				if ((world >= 250) and (world < 400)) then
				pingWorld:SetTextColor(1, 1, 0, 1);
				end
				if world >= 400 then
				pingWorld:SetTextColor(1, 0, 0, 1);
				end
			end
			if LagMonitor.db.profile.showColText == false then
				pingWorld:SetTextColor(1, 1, 0, 1);
			end
			--Display World ping
			pingWorld:SetFormattedText(world);

			--Display Game FPS
				if LagMonitor.db.profile.showColText == true then
				if floor(fps) <= 30 then
				gameFPS:SetTextColor(1, 0, 0, 1);
				end
				if ((floor(fps) > 30) and (floor(fps) <= 60)) then
				gameFPS:SetTextColor(1, 1, 0, 1);
				end
				if floor(fps) > 60 then
				gameFPS:SetTextColor(0, 1, 0, 1);
				end
			end
			if LagMonitor.db.profile.showColText == false then
				gameFPS:SetTextColor(1, 1, 0, 1);
			end
			gameFPS:SetFormattedText(floor(fps));
end

function ResetSettings()
--Reset Variables
	LagMonitor.db.profile.showColText = true;
	LagMonitor.db.profile.short = false;
	LagMonitor.db.profile.closed = false;
	LagMonitor.db.profile.isClamped = false;
	LagMonitor.db.profile.locked = false;
	LagMonitor.db.profile.homePingShow = true;
	LagMonitor.db.profile.worldPingShow = true;
	LagMonitor.db.profile.fpsShow = true;
	LagMonitor.db.profile.showCurrency = false;
	LagMonitor.db.profile.bcGroup = defaultGroup;
	LagMonitor.db.profile.showItemLevel = false;
	LagMonitor.db.profile.backgroundcol = 1;
	LagMonitor.db.profile.statsPoint = "CENTER";
	LagMonitor.db.profile.statsRelativePoint = "CENTER";
	LagMonitor.db.profile.statsxOfs = 0;
	LagMonitor.db.profile.statsyOfs = 0;
	LagMonitor.db.profile.itemPoint = "CENTER";
	LagMonitor.db.profile.itemRelativePoint = "TOP"
	LagMonitor.db.profile.itemxOfs = 0;
	LagMonitor.db.profile.itemyOfs = -50;
	LagMonitor.db.profile.currencyPoint = "CENTER";
	LagMonitor.db.profile.currencyRelativePoint = "TOP";
	LagMonitor.db.profile.currencyxOfs = 0;
	LagMonitor.db.profile.currencyyOfs = -25;
	LagMonitor.db.profile.statsHeight = statsFramesHeight;
	LagMonitor.db.profile.statsWidth = statsFramesWitdh;
	LagMonitor.db.profile.ilevelHeight = itemFrameHeight;
	LagMonitor.db.profile.ilevelWidth = itemFrameWidth;
	LagMonitor.db.profile.currencyHeight = currencyFrameHeight;
	LagMonitor.db.profile.currencyWidth = currencyFrameWidth;
	
--Show Frames
	AddonLoaded();

--Reset Points
	lagMonitorFrame:ClearAllPoints();
	currencyFrame:ClearAllPoints();
	ilevelFrame:ClearAllPoints();
	
--Reset frame positions
	framePositions();
	
--Reset Appearance	
	LagMonitorBody:SetVertexColor(0.1, 0.1, 0.1, LagMonitor.db.profile.backgroundcol);
	IlevelBody:SetVertexColor(0.1, 0.1, 0.1, LagMonitor.db.profile.backgroundcol);
	CurrencyBody:SetVertexColor(0.1, 0.1, 0.1, LagMonitor.db.profile.backgroundcol);
	
--Reset Size
	lagMonitorFrame:SetSize(statsFramesWitdh, statsFramesHeight);
	ilevelFrame:SetSize(itemFrameWidth, itemFrameHeight);
	currencyFrame:SetSize(currencyFrameWidth, currencyFrameHeight);

--Reset Fonts
	LagMonitor.db.profile.fontSize = 15;
	LagMonitor.db.profile.thickOutline = false;
	LagMonitor.db.profile.activeFont = defaultFont;
	myFont = LSM:Fetch("font","Font" .. defaultFont);
	LagMonitor:Print("Reset to default settings!");
end